//
// MoonCanvas.h
// Draw the moon and related info.
//
//    Copyright 2002 by Akkana Peck.
// You may use or distribute this code under the terms of the GPL.
//

#ifndef QMOONCANVAS_H
#define QMOONCANVAS_H

#include "MoonCanvas.h"

#include "qwidget.h"

#include <qstring.h>

#include <sys/time.h>

class QImage;
class MoonFeature;
class QPainter;

class QMoonCanvas : public QWidget, public MoonCanvas
{
    Q_OBJECT
public:
    QMoonCanvas( QWidget *parent=0, const char *name=0 );
    virtual ~QMoonCanvas();

    void Zoom(int level);

    void Clear();
    virtual void Paint();

    virtual void SetColor(int r, int g, int b);

    virtual void DrawLine(int x1, int y1, int x2, int y2);
    virtual void DrawEllipse(int x, int y, int w, int h);
    virtual void DrawString(char* str, int x, int y);

    virtual int Width();
    virtual int Height();

public slots:

signals:

protected:
    QImage* mMoonImg;
    QPainter* mPainter;

    // Save description strings in case we get a chance to show them
    QString mDescriptions;

    // Time of last mouse button down event:
    struct timeval mLastButtonDownTime;

    void PaintFeature(MoonFeature* feature);

    // Override QWidget:
    virtual void paintEvent(QPaintEvent* event);

    void mousePressEvent(QMouseEvent *event);
    void mouseReleaseEvent(QMouseEvent *event);

    //QSize minimumSizeHint() const;
};

#endif // QMOONCANVAS_H
